/* GyvePrinter.h --- 

   Copyright (C) 1998 Free Software Foundation, Inc.

   Written by:  Masatake YAMATO <masata-y@is.aist-nara.ac.jp>
   
   This file is part of the GNU Yellow Vector Editor

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */ 

#ifndef GYVE_PRINTER_H
#define GYVE_PRINTER_H 
#include <stdio.h>
#include <Foundation/NSObject.h>
#include <gyve/GyveVisitor.h>
#include <DPS/dpsXuserpath.h>

@class GyveBuffer, NSString;

@protocol GyvePrinter
- (void)print;
@end

@interface GyveEPSPrinter: GyveVisitor<GyvePrinter>
{
  FILE * fp;
  int indent_offset;
}
- initWithFilePath: (NSString *)path buffer: (GyveBuffer *)b;
- (void)print;
- (void)dealloc;
- (void)printHeader;
- (void)printFooter;
@end

#endif /* Not def: GYVE_PRINTER_H */
