/* PSColor.h --- 

   Copyright (C) 1998 Free Software Foundation, Inc.

   Written by:  Masatake YAMATO <masata-y@is.aist-nara.ac.jp>
   
   This file is part of the GNU Yellow Vector Editor

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */ 

#ifndef P_S_COLOR_H
#define P_S_COLOR_H 

#define RED_INDEX 0
#define GREEN_INDEX 1
#define BLUE_INDEX 2

struct color 
{
  float red;
  float green;
  float blue;
};

void color_init_as_white(struct color * color);
void color_init_as_black(struct color * color);
float color_element_round(float elt);
float color_element_from_char(unsigned char c);

@protocol PSColor
- (float)red;
- (float)green;
- (float)blue;
@end


#endif /* Not Def: P_S_COLOR_H */
